var app = {

  initialize: function initialize() {
    document.addEventListener('deviceready', FunctionUtils.bind(this, this.onDeviceReady), false);
  },

  // http://docs.phonegap.com/en/3.5.0/cordova_events_events.md.html#Events
  bindEvents: function bindEvents() {
    document.addEventListener('resume', this.didAppStateChange, false);
    document.addEventListener('backbutton', this.didPressBackButton, false);
  },

  didAppStateChange: function didAppStateChange(event) {
    require(['touch/app/NavigationController'], function(AppNavigationController) {
      if (event.type === 'resume') {
        AppNavigationController.didAppEnterForeground();
      }
    });
  },

  didPressBackButton: function didPressBackButton(event) {
    AppNavigationController.didPressBackButton(event);
  },

  onDeviceReady: function onDeviceReady() {
    this.bindEvents();
    DOM.addClass(jQuery('body'), 'platform-'+device.platform.toLowerCase());

    require(
      [
        'touch/app/Runtime',
        ''
      ],
      function(
        Runtime,
        junk
      ) {
        Runtime.baseUrl = AppConfig.baseUrl;
        Runtime.isApp = true;
        Runtime.isDev = AppConfig.isDev;

        require(['touch/app/Init']);
      }
    );
  }
};

function handleOpenURL(url) {
  // Safari and Chrome differ in how they parse a non-standard url
  url = url.replace('bux://', 'https://');
  var parsedUrl = Url.parse(url);
  require(['touch/app/NavigationController'], function(AppNavigationController) {
    AppNavigationController.didAppOpenUrl(parsedUrl);
    return;
  });
}

app.initialize();

